diff --git a/src/qmplay2/StreamMuxer.cpp b/src/qmplay2/StreamMuxer.cpp
index 1660072f..ecf62729 100644
--- a/src/qmplay2/StreamMuxer.cpp
+++ b/src/qmplay2/StreamMuxer.cpp
@@ -21,12 +21,23 @@
 #include <StreamInfo.hpp>
 #include <Packet.hpp>
 
-#include <QLoggingCategory>
+#include <QDebug>
+
+#if QT_VERSION >= QT_VERSION_CHECK(5, 2, 0)
+    #include <QLoggingCategory>
+    Q_LOGGING_CATEGORY(mux, "StreamMuxer")
+    #define LOG_DEBUG() LOG_DEBUG()
+    #define LOG_WARNING() LOG_WARNING()
+    #define LOG_CRITICAL() LOG_CRITICAL()
+#else
+    // Qt4: No QLoggingCategory, use qDebug/qWarning/qCritical with category prefix
+    #define LOG_DEBUG() qDebug() << "StreamMuxer:"
+    #define LOG_WARNING() qWarning() << "StreamMuxer:"
+    #define LOG_CRITICAL() qCritical() << "StreamMuxer:"
+#endif
 
 #include <unordered_map>
 
-Q_LOGGING_CATEGORY(mux, "StreamMuxer")
-
 extern "C"
 {
     #include <libavformat/avformat.h>
@@ -70,7 +81,7 @@ StreamMuxer::StreamMuxer(const QString &fileName, const QList<StreamInfo *> &str
         {
             if (streamInfo->params->codec_type == AVMEDIA_TYPE_AUDIO)
             {
-                Q_ASSERT(format == QStringLiteral("wav"));
+                Q_ASSERT(format == QString("wav"));
                 codecId = AV_CODEC_ID_PCM_F32LE;
             }
             else
@@ -179,7 +190,7 @@ bool StreamMuxer::write(const Packet &packet, const int idx)
     {
         if (!packet.hasKeyFrame())
         {
-            qCDebug(mux) << "Skipping first packet, because it is not key frame, stream:" << idx;
+            LOG_DEBUG() << "Skipping first packet, because it is not key frame, stream:" << idx;
             return true; // Skip packet if we can't start with key frame
         }
 
@@ -213,7 +224,7 @@ bool StreamMuxer::write(const Packet &packet, const int idx)
     }
     if (!dtsOk)
     {
-        qCWarning(mux) << "Skipping packet with invalid dts in stream" << idx;
+        LOG_WARNING() << "Skipping packet with invalid dts in stream" << idx;
         return true;
     }
 
diff --git a/src/qmplay2/VideoFilter.cpp b/src/qmplay2/VideoFilter.cpp
index 12b40389..78191d91 100644
--- a/src/qmplay2/VideoFilter.cpp
+++ b/src/qmplay2/VideoFilter.cpp
@@ -19,6 +19,7 @@
 #include <VideoFilter.hpp>
 
 #include <QDebug>
+#include <cmath>
 
 #ifdef USE_VULKAN
 #   include <QMPlay2Core.hpp>
@@ -65,7 +66,7 @@ void VideoFilter::clearBuffer()
     m_internalQueue.clear();
 
     m_secondFrame = false;
-    m_lastTS = qQNaN();
+    m_lastTS = std::numeric_limits<double>::quiet_NaN();
 }
 
 bool VideoFilter::removeLastFromInternalBuffer()
@@ -81,7 +82,7 @@ bool VideoFilter::removeLastFromInternalBuffer()
 void VideoFilter::processParamsDeint()
 {
     m_secondFrame = false;
-    m_lastTS = qQNaN();
+    m_lastTS = std::numeric_limits<double>::quiet_NaN();
 
     m_deintFlags = getParam("DeinterlaceFlags").toInt();
 }
@@ -90,7 +91,7 @@ void VideoFilter::addFramesToInternalQueue(QQueue<Frame> &framesQueue)
 {
     while (!framesQueue.isEmpty())
     {
-        const Frame &videoFrame = framesQueue.constFirst();
+        const Frame &videoFrame = framesQueue.first();
         if (videoFrame.isEmpty() || (!m_supportedPixelFormats.isEmpty() && !m_supportedPixelFormats.contains(videoFrame.pixelFormat())))
             break;
         m_internalQueue.enqueue(framesQueue.dequeue());
@@ -100,7 +101,7 @@ void VideoFilter::addFramesToDeinterlace(QQueue<Frame> &framesQueue)
 {
     while (!framesQueue.isEmpty())
     {
-        const Frame &videoFrame = framesQueue.constFirst();
+        const Frame &videoFrame = framesQueue.first();
         if (videoFrame.isEmpty() || (!m_supportedPixelFormats.isEmpty() && !m_supportedPixelFormats.contains(videoFrame.pixelFormat())))
             break;
         if ((m_deintFlags & AutoDeinterlace) && !videoFrame.isInterlaced())
@@ -120,7 +121,8 @@ void VideoFilter::deinterlaceDoublerCommon(Frame &frame)
         m_internalQueue.removeFirst();
     }
 
-    if (m_secondFrame || qIsNaN(m_lastTS))
+    // Qt4/Qt5: Use std::isnan instead of std::isnan
+    if (m_secondFrame || std::isnan(m_lastTS))
         m_lastTS = initialTS;
 
     m_secondFrame = !m_secondFrame;
diff --git a/src/qmplay2/VideoFilter.hpp b/src/qmplay2/VideoFilter.hpp
index 7bf62102..938da4e5 100644
--- a/src/qmplay2/VideoFilter.hpp
+++ b/src/qmplay2/VideoFilter.hpp
@@ -18,6 +18,8 @@
 
 #pragma once
 
+#include <limits>
+
 #include <ModuleCommon.hpp>
 #include <ModuleParams.hpp>
 #include <Frame.hpp>
@@ -98,7 +100,7 @@ protected:
 
     // For doubler
     bool m_secondFrame = false;
-    double m_lastTS = qQNaN();
+    double m_lastTS = std::numeric_limits<double>::quiet_NaN();
 
 #ifdef USE_VULKAN
     std::shared_ptr<QmVk::HWInterop> m_vkHwInterop;
diff --git a/src/qmplay2/VideoFilters.cpp b/src/qmplay2/VideoFilters.cpp
index c96a71cc..d056308d 100644
--- a/src/qmplay2/VideoFilters.cpp
+++ b/src/qmplay2/VideoFilters.cpp
@@ -72,7 +72,7 @@ public:
 
     QMutex bufferMutex;
 private:
-    void run() override
+    void run()
     {
         while (!br)
         {
@@ -90,7 +90,7 @@ private:
             bool pending = false;
             do
             {
-                for (const std::shared_ptr<VideoFilter> &vFilter : std::as_const(videoFilters.filters))
+                for (const std::shared_ptr<VideoFilter> &vFilter : videoFilters.filters)
                     pending |= vFilter->filter(queue);
 
                 if (queue.isEmpty())
@@ -201,7 +201,7 @@ void VideoFilters::clearBuffers()
     if (!filters.isEmpty())
     {
         filtersThr.waitForFinished(true);
-        for (auto &&vFilter : std::as_const(filters))
+        for (auto &&vFilter : filters)
             vFilter->clearBuffer();
     }
     outputQueue.clear();
diff --git a/src/qmplay2/VideoOutputCommon.cpp b/src/qmplay2/VideoOutputCommon.cpp
index 7b6dbb42..bbcfcd7a 100644
--- a/src/qmplay2/VideoOutputCommon.cpp
+++ b/src/qmplay2/VideoOutputCommon.cpp
@@ -28,19 +28,48 @@
 using namespace std;
 using namespace placeholders;
 
+// Qt4 helper: QSizeF::scaled() doesn't exist
+#if QT_VERSION < QT_VERSION_CHECK(5, 0, 0)
+static QSizeF scaledSizeF(const QSizeF &size, const QSizeF &target, Qt::AspectRatioMode mode)
+{
+    QSizeF result = size;
+    if (mode == Qt::KeepAspectRatio || mode == Qt::KeepAspectRatioByExpanding)
+    {
+        qreal widthRatio = target.width() / size.width();
+        qreal heightRatio = target.height() / size.height();
+        qreal ratio;
+        if (mode == Qt::KeepAspectRatio)
+            ratio = qMin(widthRatio, heightRatio);
+        else
+            ratio = qMax(widthRatio, heightRatio);
+        result = QSizeF(size.width() * ratio, size.height() * ratio);
+    }
+    else if (mode == Qt::IgnoreAspectRatio)
+    {
+        result = target;
+    }
+    return result;
+}
+#endif
+
 VideoOutputCommon::VideoOutputCommon(bool yInverted)
     : m_yMultiplier(yInverted ? -1.0f : 1.0f)
 {
     m_rotAnimation.setEasingCurve(QEasingCurve::OutQuint);
     m_rotAnimation.setDuration(1000.0);
-
-    QObject::connect(&m_rotAnimation, &QVariantAnimation::valueChanged,
-                     bind(&VideoOutputCommon::rotValueUpdated, this, _1));
 }
 VideoOutputCommon::~VideoOutputCommon()
 {
 }
 
+void VideoOutputCommon::setupAnimationConnection(QObject *receiver)
+{
+    // Derived classes that have QObject should call this and provide themselves
+    // The signal will be connected via a slot in the derived class
+    Q_UNUSED(receiver);
+    // Connection is actually done in derived classes that have Q_OBJECT
+}
+
 QWidget *VideoOutputCommon::widget() const
 {
     return m_widget;
@@ -78,7 +107,12 @@ bool VideoOutputCommon::setSphericalView(bool sphericalView)
 
 QSize VideoOutputCommon::getRealWidgetSize(bool lh) const
 {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     const auto widgetSizeF = m_widget->devicePixelRatioF() * QSizeF(m_widget->size() + QSize(0, lh ? m_widget->property("loseHeight").toInt() : 0));
+#else
+    // Qt4: No HiDPI support, devicePixelRatio is always 1.0
+    const auto widgetSizeF = QSizeF(m_widget->size() + QSize(0, lh ? m_widget->property("loseHeight").toInt() : 0));
+#endif
     return QSize(
         widgetSizeF.width(),
         widgetSizeF.height()
@@ -99,16 +133,28 @@ void VideoOutputCommon::updateSizes(bool transpose)
 {
     const auto size = getRealWidgetSize(true);
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     const auto scaledSize = m_zoom * (transpose
         ? QSizeF(1.0, m_aRatio).scaled(size, Qt::KeepAspectRatio)
         : QSizeF(m_aRatio, 1.0).scaled(size, Qt::KeepAspectRatio)
     );
+#else
+    // Qt4: Use helper function
+    const auto scaledSize = m_zoom * (transpose
+        ? scaledSizeF(QSizeF(1.0, m_aRatio), size, Qt::KeepAspectRatio)
+        : scaledSizeF(QSizeF(m_aRatio, 1.0), size, Qt::KeepAspectRatio)
+    );
+#endif
     m_scaledSize = QSize( // round down to int
         scaledSize.width(),
         scaledSize.height()
     );
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
     const auto subsScaledSize = m_zoom * QSizeF(m_aRatio, 1.0).scaled(size, Qt::KeepAspectRatio);
+#else
+    const auto subsScaledSize = m_zoom * scaledSizeF(QSizeF(m_aRatio, 1.0), size, Qt::KeepAspectRatio);
+#endif
     const auto subsScaledPos = (size - subsScaledSize) / 2.0;
     m_subsRect.setRect( // round down to int
         subsScaledPos.width(),
@@ -134,7 +180,12 @@ void VideoOutputCommon::updateMatrix()
     }
     if (int loseHeight = m_widget->property("loseHeight").toInt())
     {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         m_matrix.translate(0, -loseHeight * m_widget->devicePixelRatioF() * m_yMultiplier / m_scaledSize.height());
+#else
+        // Qt4: No HiDPI support, devicePixelRatio is always 1.0
+        m_matrix.translate(0, -loseHeight * m_yMultiplier / m_scaledSize.height());
+#endif
     }
 
     if (m_sphericalView)
@@ -211,7 +262,11 @@ void VideoOutputCommon::mouseMove(QMouseEvent *e)
 
         if (m_moveVideo)
         {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
             const auto dpr = m_widget->devicePixelRatioF();
+#else
+            const auto dpr = 1.0;
+#endif
             m_videoOffset += QPointF(
                 mouseDiff.x() * dpr * 2.0 / m_scaledSize.width(),
                 mouseDiff.y() * dpr * 2.0 / m_scaledSize.height()
@@ -274,7 +329,12 @@ void VideoOutputCommon::mouseMove360(QMouseEvent *e)
         m_mouseTime = currTime;
 
         m_mousePos = newMousePos;
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
         if (e->source() == Qt::MouseEventNotSynthesized)
+#else
+        // Qt4: No QMouseEvent::source(), assume all mouse events are real
+        if (true)
+#endif
         {
             m_mouseWrapped = m_canWrapMouse
                 ? Functions::wrapMouse(m_widget, m_mousePos, 1)
diff --git a/src/qmplay2/VideoOutputCommon.hpp b/src/qmplay2/VideoOutputCommon.hpp
index 6ef8d379..2d7dcc06 100644
--- a/src/qmplay2/VideoOutputCommon.hpp
+++ b/src/qmplay2/VideoOutputCommon.hpp
@@ -30,6 +30,21 @@ class QMouseEvent;
 class QVariant;
 class QWidget;
 
+// Qt4 compatibility: QVariantAnimation is abstract in Qt4
+class Qt4VariantAnimation : public QVariantAnimation
+{
+    Q_OBJECT
+public:
+    Qt4VariantAnimation(QObject *parent = nullptr) : QVariantAnimation(parent) {}
+
+protected:
+    void updateCurrentValue(const QVariant &value)
+    {
+        // Emit valueChanged signal for compatibility
+        emit valueChanged(value);
+    }
+};
+
 class VideoOutputCommon : public X11BypassCompositor
 {
 protected:
@@ -43,6 +58,9 @@ public:
 
     virtual bool setSphericalView(bool sphericalView);
 
+    // For derived classes with QObject to call to set up animation connection
+    void setupAnimationConnection(QObject *receiver);
+
 protected:
     QSize getRealWidgetSize(bool lh = false) const;
 
@@ -62,9 +80,10 @@ protected:
     void mouseMove360(QMouseEvent *e);
     void mouseRelease360(QMouseEvent *e);
 
-private:
     void rotValueUpdated(const QVariant &value);
 
+private:
+
 protected:
     const float m_yMultiplier;
 
@@ -79,7 +98,7 @@ protected:
 
     QMatrix4x4 m_matrix;
 
-    QVariantAnimation m_rotAnimation;
+    Qt4VariantAnimation m_rotAnimation;
 
     QPointF m_videoOffset;
     QPointF m_osdOffset;
diff --git a/src/qmplay2/Writer.cpp b/src/qmplay2/Writer.cpp
index 7adfd95f..f48c17a2 100644
--- a/src/qmplay2/Writer.cpp
+++ b/src/qmplay2/Writer.cpp
@@ -20,7 +20,12 @@
 
 #include <Functions.hpp>
 
-#include <QSaveFile>
+#if QT_VERSION >= QT_VERSION_CHECK(5, 1, 0)
+    #include <QSaveFile>
+#else
+    // Qt4: No QSaveFile, use QFile instead
+    #include <QFile>
+#endif
 #include <QBuffer>
 #ifdef Q_OS_ANDROID
 #   include <QFile>
@@ -41,7 +46,7 @@ class IODeviceWriter : public Writer
     }
 
 protected:
-    bool open() override
+    bool open()
     {
         return m_io->open(QIODevice::WriteOnly);
     }
@@ -55,8 +60,14 @@ class QMPlay2FileWriter : public IODeviceWriter
 {
     ~QMPlay2FileWriter()
     {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 1, 0)
         if (auto f = static_cast<QSaveFile *>(m_io.get()))
             f->commit();
+#else
+        // Qt4: Using QFile, no commit needed
+        if (auto f = static_cast<QFile *>(m_io.get()))
+            f->close();
+#endif
     }
 
     QString name() const override final
@@ -72,7 +83,12 @@ class QMPlay2FileWriter : public IODeviceWriter
             m_io.reset(new QFile(url));
         else
 #endif
+#if QT_VERSION >= QT_VERSION_CHECK(5, 1, 0)
             m_io.reset(new QSaveFile(url.mid(7)));
+#else
+            // Qt4: Use QFile instead of QSaveFile
+            m_io.reset(new QFile(url.mid(7)));
+#endif
         return IODeviceWriter::open();
     }
 };
diff --git a/src/qmplay2/X11BypassCompositor.cpp b/src/qmplay2/X11BypassCompositor.cpp
index e09b43a0..80966597 100644
--- a/src/qmplay2/X11BypassCompositor.cpp
+++ b/src/qmplay2/X11BypassCompositor.cpp
@@ -28,23 +28,30 @@ X11BypassCompositor::X11BypassCompositor()
 }
 X11BypassCompositor::~X11BypassCompositor()
 {
-    if (m_fullScreenChangedConn)
-    {
-        setX11BypassCompositor(false);
-        QObject::disconnect(m_fullScreenChangedConn);
-    }
+    setX11BypassCompositor(false);
+}
+
+void X11BypassCompositor::setFullScreenCallback(std::function<bool()> callback)
+{
+    m_fullScreenCallback = callback;
+}
+
+void X11BypassCompositor::fullScreenChanged(bool fullScreen)
+{
+    m_isFullScreen = fullScreen;
+    setX11BypassCompositor(m_bypassCompositor);
 }
 
 void X11BypassCompositor::setX11BypassCompositor(bool bypassCompositor)
 {
-    if (!m_fullScreenChangedConn)
+    if (!m_fullScreenCallback && QMPlay2Core.getMainWindow())
     {
-        m_fullScreenChangedConn = QObject::connect(&QMPlay2Core, &QMPlay2CoreClass::fullScreenChanged, [this](bool fullScreen) {
-            m_isFullScreen = fullScreen;
-            setX11BypassCompositor(m_bypassCompositor);
-        });
         m_isFullScreen = QMPlay2Core.getMainWindow()->property("fullScreen").toBool();
     }
+    else if (m_fullScreenCallback)
+    {
+        m_isFullScreen = m_fullScreenCallback();
+    }
 
     m_bypassCompositor = bypassCompositor;
 
diff --git a/src/qmplay2/X11BypassCompositor.hpp b/src/qmplay2/X11BypassCompositor.hpp
index 5a7ca81c..3a1abaa3 100644
--- a/src/qmplay2/X11BypassCompositor.hpp
+++ b/src/qmplay2/X11BypassCompositor.hpp
@@ -20,21 +20,23 @@
 
 #include <QMPlay2Lib.hpp>
 
-#include <QMetaObject>
+#include <functional>
 
 class QMPLAY2SHAREDLIB_EXPORT X11BypassCompositor
 {
-    Q_DISABLE_COPY(X11BypassCompositor)
-
 public:
     X11BypassCompositor();
     ~X11BypassCompositor();
 
     void setX11BypassCompositor(bool bypassCompositor);
+    void setFullScreenCallback(std::function<bool()> callback);
+
+protected:
+    void fullScreenChanged(bool fullScreen);
 
 private:
     bool m_bypassCompositor = false;
     bool m_compositorBypassed = false;
     bool m_isFullScreen = false;
-    QMetaObject::Connection m_fullScreenChangedConn;
+    std::function<bool()> m_fullScreenCallback;
 };
diff --git a/src/qmplay2/YouTubeDL.cpp b/src/qmplay2/YouTubeDL.cpp
index 39e6a517..897dddf4 100644
--- a/src/qmplay2/YouTubeDL.cpp
+++ b/src/qmplay2/YouTubeDL.cpp
@@ -23,11 +23,16 @@
 #include <Functions.hpp>
 #include <Settings.hpp>
 
-#include <QRegularExpression>
-#include <QStandardPaths>
-#include <QJsonDocument>
-#include <QJsonObject>
-#include <QJsonArray>
+#include <QRegExp>
+#include <QUrl>
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+    #include <QStandardPaths>
+#else
+    #include <QProcess>
+#endif
+#include <QJsonDocument.h>
+#include <QJsonObject.h>
+#include <QJsonArray.h>
 #include <QFileInfo>
 #include <QMutex>
 #include <QFile>
@@ -35,7 +40,61 @@
 
 constexpr const char *g_name = "YouTubeDL";
 static bool g_mustUpdate = true;
+#if QT_VERSION >= QT_VERSION_CHECK(5, 14, 0)
 static QRecursiveMutex g_mutex;
+#else
+static QMutex g_mutex(QMutex::Recursive);
+#endif
+
+#if QT_VERSION < QT_VERSION_CHECK(5, 15, 0)
+// Qt4/older Qt5: reimplementation of QProcess::splitCommand() (added in Qt
+// 5.15), matching its documented Unix-shell-like quoting rules: single or
+// double quotes group words together, a backslash escapes the next character
+// unless inside single quotes (where everything is literal).
+static QStringList qmplay2_splitCommand(const QString &command)
+{
+    QStringList args;
+    QString tmp;
+    int quoteCount = 0;
+    QChar quoteChar;
+
+    for (int i = 0; i < command.size(); ++i)
+    {
+        const QChar c = command.at(i);
+        const bool inQuote = !quoteChar.isNull();
+        if (!inQuote && (c == '"' || c == '\''))
+        {
+            quoteChar = c;
+            ++quoteCount;
+            continue;
+        }
+        if (inQuote && c == quoteChar)
+        {
+            quoteChar = QChar();
+            continue;
+        }
+        if (quoteChar != '\'' && c == '\\' && i + 1 < command.size())
+        {
+            tmp += command.at(++i);
+            continue;
+        }
+        if (!inQuote && c.isSpace())
+        {
+            if (!tmp.isEmpty() || quoteCount)
+            {
+                args += tmp;
+                tmp.clear();
+                quoteCount = 0;
+            }
+            continue;
+        }
+        tmp += c;
+    }
+    if (!tmp.isEmpty() || quoteCount)
+        args += tmp;
+    return args;
+}
+#endif
 
 static inline QString getYtDlpFileName()
 {
@@ -159,13 +218,13 @@ void YouTubeDL::addr(const QString &url, const QString &param, QString *streamUr
         else
         {
             *streamUrl = "FFmpeg://{";
-            for (const QString &tmpUrl : std::as_const(ytdlStdout))
+            for (const QString &tmpUrl : ytdlStdout)
                 *streamUrl += "[" + tmpUrl + "]";
             *streamUrl += "}";
         }
         if (!refererHeader.isEmpty())
         {
-            for (const QString &url : std::as_const(ytdlStdout))
+            for (const QString &url : ytdlStdout)
                 QMPlay2Core.addRawHeaders(url, refererHeader);
         }
     }
@@ -174,7 +233,7 @@ void YouTubeDL::addr(const QString &url, const QString &param, QString *streamUr
     if (extension)
     {
         QStringList extensions;
-        for (const QString &tmpUrl : std::as_const(ytdlStdout))
+        for (const QString &tmpUrl : ytdlStdout)
         {
             if (tmpUrl.contains("mp4"))
                 extensions += ".mp4";
@@ -191,7 +250,7 @@ void YouTubeDL::addr(const QString &url, const QString &param, QString *streamUr
         }
         if (extensions.count() == 1)
             *extension = extensions.at(0);
-        else for (const QString &tmpExt : std::as_const(extensions))
+        else for (const QString &tmpExt : extensions)
             *extension += "[" + tmpExt + "]";
     }
 }
@@ -213,7 +272,12 @@ QStringList YouTubeDL::exec(const QString &url, const QStringList &args, QString
     {
         if (auto ap = QMPSettings.getString("YtDl/AdditionalParams").simplified(); !ap.isEmpty())
         {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 15, 0)
             processArgs += QProcess::splitCommand(ap);
+#else
+            // Qt4/older Qt5: QProcess::splitCommand() was added in Qt 5.15
+            processArgs += qmplay2_splitCommand(ap);
+#endif
         }
     }
 
@@ -242,11 +306,11 @@ QStringList YouTubeDL::exec(const QString &url, const QStringList &args, QString
         }
         else
         {
-            result = result.constFirst().split('\n', Qt::SkipEmptyParts);
+            result = result.first().split('\n', QString::SkipEmptyParts);
 
             // Verify if URLs has printable characters, because sometimes we
             // can get binary garbage at output (especially on Openload).
-            for (const QString &line : std::as_const(result))
+            for (const QString &line : result)
             {
                 if (line.startsWith("http"))
                 {
@@ -296,18 +360,39 @@ QStringList YouTubeDL::exec(const QString &url, const QStringList &args, QString
                 const QString url = result.at(i - 1);
 
                 const QJsonDocument json = QJsonDocument::fromJson(result.at(i).toUtf8());
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
                 for (const QJsonValue &formats : json["formats"].toArray())
+#else
+                // Qt4 QJson4: QJsonDocument doesn't have operator[], need to get object first
+                const QJsonObject rootObj = json.object();
+                for (const QJsonValue &formatsVal : rootObj["formats"].toArray())
+#endif
                 {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
                     if (url == formats["url"].toString())
                     {
                         auto cookies = formats["http_headers"]["Cookie"].toString();
                         if (cookies.isEmpty())
                             cookies = formats["cookies"].toString();
+#else
+                    // Qt4 QJson4: QJsonValue doesn't have operator[], need to convert to object
+                    const QJsonObject formats = formatsVal.toObject();
+                    if (url == formats["url"].toString())
+                    {
+                        const QJsonObject httpHeaders = formats["http_headers"].toObject();
+                        auto cookies = httpHeaders["Cookie"].toString();
+                        if (cookies.isEmpty())
+                            cookies = formats["cookies"].toString();
+#endif
                         QMPlay2Core.addCookies(url, cookies.toUtf8());
                     }
                 }
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+                result.remove(i);
+#else
                 result.removeAt(i);
+#endif
             }
         }
     }
@@ -334,7 +419,11 @@ bool YouTubeDL::prepare()
             return false;
     }
 
+#if QT_VERSION >= QT_VERSION_CHECK(5, 2, 0)
     if (!QFileInfo::exists(m_ytDlPath))
+#else
+    if (!QFileInfo(m_ytDlPath).exists())
+#endif
     {
         if (!download())
         {
@@ -373,7 +462,11 @@ bool YouTubeDL::download()
 
     if (!getCustomFilePath().isEmpty())
     {
+#if QT_VERSION >= QT_VERSION_CHECK(5, 5, 0)
         qInfo() << "\"youtube-dl\" is not downloading to custom path";
+#else
+        qDebug() << "\"youtube-dl\" is not downloading to custom path";
+#endif
         return false;
     }
 
@@ -462,7 +555,7 @@ bool YouTubeDL::update()
         {
             qCritical() << "youtube-dl update failed:" << updateOutput;
         }
-        else if (m_process.exitCode() == 0 && !updateOutput.contains(QRegularExpression(R"(up\Wto\Wdate)")))
+        else if (m_process.exitCode() == 0 && !updateOutput.contains(QRegExp("up\\Wto\\Wdate")))
         {
             QMPlay2Core.setWorking(false);
             emit QMPlay2Core.sendMessage(tr("\"youtube-dl\" has been successfully updated!"), g_name);
@@ -514,12 +607,28 @@ void YouTubeDL::startProcess(QStringList args)
         if (shebang.startsWith("#!") && idx > -1)
         {
             const auto pythonCmd = shebang.mid(idx);
-            if (QStandardPaths::findExecutable(pythonCmd).endsWith(pythonCmd))
+#if QT_VERSION >= QT_VERSION_CHECK(5, 0, 0)
+            const QString foundPython = QStandardPaths::findExecutable(pythonCmd);
+#else
+            // Qt4: No findExecutable, search PATH manually
+            QString foundPython;
+            const QStringList paths = QString::fromLocal8Bit(qgetenv("PATH")).split(':');
+            for (const QString &path : paths)
+            {
+                const QString fullPath = path + "/" + pythonCmd;
+                if (QFileInfo(fullPath).isExecutable())
+                {
+                    foundPython = fullPath;
+                    break;
+                }
+            }
+#endif
+            if (foundPython.endsWith(pythonCmd))
             {
                 args.prepend(program);
                 program = pythonCmd;
             }
-#ifdef Q_OS_MACOS
+#ifdef Q_OS_MAC
             else if (QFileInfo(QString("/usr/local/bin/" + pythonCmd)).isExecutable())
             {
                 args.prepend(program);
diff --git a/src/qmplay2/YouTubeDL.hpp b/src/qmplay2/YouTubeDL.hpp
index a7426e8f..631a107f 100644
--- a/src/qmplay2/YouTubeDL.hpp
+++ b/src/qmplay2/YouTubeDL.hpp
@@ -26,7 +26,7 @@
 
 class NetworkReply;
 
-class QMPLAY2SHAREDLIB_EXPORT YouTubeDL final : public BasicIO
+class QMPLAY2SHAREDLIB_EXPORT YouTubeDL : public BasicIO
 {
     Q_DECLARE_TR_FUNCTIONS(YouTubeDL)
     Q_DISABLE_COPY(YouTubeDL)
@@ -45,7 +45,7 @@ public:
     QStringList exec(const QString &url, const QStringList &args, QString *silentErr = nullptr, bool rawOutput = false);
 
 private:
-    void abort() override;
+    void abort();
 
 private:
     bool prepare();
